#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include "mem.h"

// do NOT include obfuscation header file for this source
// that would be quite pointless..

void memory_init(memory_t *mem, int maxsize)
{
	mem->left = maxsize;
	mem->used = 0;
	mem->_mem = malloc(maxsize);
}

void *memory_get(memory_t *mem, int size)
{
	if(mem->left < size) return NULL;

	void *ret = ((unsigned char *) mem->_mem) + mem->used;
	mem->used += size;
	mem->left -= size;

	return ret;
}

void memory_status(memory_t *mem, int *used, int *left)
{
	*used = mem->used;
	*left = mem->left;
}

void memory_destroy(memory_t *mem)
{
	free(mem->_mem);
	memset(mem, 0, sizeof(memory_t));
}
