#include <stdio.h>
#include <windows.h>

#define FORCEDINLINE __forceinline

void calculate_data(int in, int *out)
{
    // stores five times the input `in' into `out'
    *out = in * 5;
}

FORCEDINLINE void calculate_data_obf(int in, int *out)
{
    static unsigned long hash = 0; unsigned long h = 0;
    // calculate the hash of the calculate_data function
    // and whatever is behind it (e.g. main)
    for (int i = 0; i < 0x200; i++) {
        h += *((unsigned char *) &calculate_data + i);
    }
    // first time we check?
    if(hash == 0) {
        // then set the hash
        hash = h;
    }
    else if(hash != h) {
        printf("memory has been altered (in: %d, out: 0x%08x)!\n",
            in, out);
        return;
    }
    // hash checks out, call the original function.
    calculate_data(in, out);
}

void overwrite_function()
{
    // windows only, doh.
    DWORD old;
    VirtualProtect(&calculate_data, 1, PAGE_EXECUTE_READWRITE, &old);

    // overwrite the first instruction with a return instruction
    // this way the `out' variable will not be set.
    *(unsigned char *) &calculate_data = 0xc3;
}

#define calculate_data calculate_data_obf

int main(void)
{
    for (int i = 0, out; i < 25; i++) {
        calculate_data(i, &out);
        printf("%d -> %d\n", i, out);

        // the 10th time we will patch the function
        if(i == 10) {
            overwrite_function();
        }
    }
}
